<template>
	<v-list-item-content v-if="isLoaded && !hasError">
		<router-link :to="`sampling-collection/${samplingCollection.id}`">
			<v-list-item-title v-if="samplingCollection.dateCreated">
				{{ field.name }} -
				{{ new Date(samplingCollection.dateCreated).toLocaleString() }}
				<span class="text-caption">(created)</span>
			</v-list-item-title>
		</router-link>
		<v-list-item-subtitle> <span class="font-weight-medium">Field:</span> {{ field.name }} </v-list-item-subtitle>
		<v-list-item-subtitle v-if="samplingCollection.dateModified">
			<span class="font-weight-medium">Last modified:</span>
			{{ new Date(samplingCollection.dateModified).toLocaleString() }}
		</v-list-item-subtitle>
		<v-list-item-subtitle>
			<v-icon small class="mr-1"> mdi-triangle </v-icon>{{ progressText }} locations collected
		</v-list-item-subtitle>
	</v-list-item-content>
</template>

<script lang="ts">
import { defineComponent, computed, ComputedRef } from '@vue/composition-api';
import { SamplingCollection, Sampling, Field, SamplingCollectionStatus } from '@/store/types';
import { useAllResources } from '@/store/modules/resources';
import { useAllSamplingCollections } from '@/store/modules/samplingCollections';
import { useAllSamplings } from '@/store/modules/samplings';

export default defineComponent({
	props: {
		id: {
			required: true,
			type: String,
		},
	},
	setup(props, { root }) {
		const {
			isLoaded: resourcesAreLoaded,
			hasError: resourcesHaveError,
			samplingCollections: submittedSamplingCollections,
		} = useAllResources(root.$store);

		const {
			isLoaded: draftsAreLoaded,
			hasError: draftsHaveError,
			samplingCollections: draftSamplingCollections,
		} = useAllSamplingCollections(root.$store);

		const { isLoaded: samplingsAreLoaded, hasError: samplingsHaveError } = useAllSamplings(root.$store);

		const isLoaded = computed(() => resourcesAreLoaded.value && draftsAreLoaded.value && samplingsAreLoaded.value);

		const hasError = computed(() =>
			[draftsHaveError.value, samplingsHaveError.value, resourcesHaveError.value].some(Boolean)
		);

		const samplingCollectionStatus: ComputedRef<SamplingCollectionStatus> = computed(() =>
			root.$store.getters.getSamplingCollectionStatusBySamplingCollectionId(props.id)
		);

		const samplingCollection: ComputedRef<SamplingCollection | undefined> = computed(
			() =>
				submittedSamplingCollections.value?.find(({ id }: SamplingCollection) => id === props.id) ||
				draftSamplingCollections.value?.find(({ id }: SamplingCollection) => id === props.id)
		);

		const field: ComputedRef<Field | undefined> = computed(() =>
			root.$store.getters['resources/getFieldById'](samplingCollection.value?.featureOfInterest)
		);

		const samplings: ComputedRef<Sampling[]> = computed(() => {
			if (samplingCollectionStatus.value === 'SUBMITTED') {
				return root.$store.getters['resources/getSamplingsBySamplingCollectionId'](props.id);
			}
			if (samplingCollectionStatus.value === 'DRAFT') {
				return root.$store.getters['samplings/getBySamplingCollectionId'](props.id);
			}
			return [];
		});

		const locations: ComputedRef<Location[]> = computed(() =>
			root.$store.getters['resources/getLocationsByFieldId'](samplingCollection.value?.featureOfInterest)
		);

		const progressText: ComputedRef<string> = computed(() =>
			isLoaded.value ? `${samplings.value.length} / ${locations.value.length}` : ''
		);

		return {
			samplingCollection,
			field,
			progressText,
			isLoaded,
			hasError,
		};
	},
});
</script>

<style></style>
